#!/bin/sh
# Copyright 2019 Collabora Ltd.
# SPDX-License-Identifier: Zlib
# (see "zlib/libpng" in debian/copyright)

set -eux

if [ -n "${AUTOPKGTEST_ARTIFACTS-}" ]; then
	WORKDIR="$AUTOPKGTEST_ARTIFACTS"
else
	WORKDIR="$(mktemp -d)"
	trap 'cd /; rm -fr "$WORKDIR"' 0 INT QUIT ABRT PIPE TERM
fi

if [ -n "${DEB_HOST_GNU_TYPE:-}" ]; then
    CROSS_COMPILE="$DEB_HOST_GNU_TYPE-"
else
    CROSS_COMPILE=
fi

cp showfont.c "$WORKDIR"
mkdir "$WORKDIR/cmake"
cp ./cmake/test/CMakeLists.txt "$WORKDIR/cmake"
cp ./cmake/test/main.c "$WORKDIR/cmake"

cd "$WORKDIR"

# Deliberately word-splitting pkg-config's output:
# shellcheck disable=SC2046
"${CROSS_COMPILE}gcc" -oshowfont showfont.c $("${CROSS_COMPILE}pkg-config" --cflags --libs SDL2_ttf)

set -- ./showfont

if [ -z "${TEST_INTERACTIVE-}" ]; then
	echo "(export TEST_INTERACTIVE=1 for an interactive test)"
	set -- xvfb-run -a "$@" -dump
fi

set -- "$@" /usr/share/fonts/opentype/cantarell/Cantarell-Regular.otf

"$@"

if [ -z "${TEST_INTERACTIVE-}" ]; then
	file glyph-100.bmp
fi

if [ -z "${DEB_HOST_GNU_TYPE:-}" ]; then
    mkdir cmake/_build
    ( cd cmake/_build; cmake -GNinja -DTEST_SHARED=ON -DTEST_STATIC=ON .. )
    ninja -C cmake/_build
    ./cmake/_build/main_shared
    ./cmake/_build/main_static
fi
